Intuition behind storing sum and frequency in the HashMap

Viewed 817

We have been given an array of integers and another number k and we need to find the total number of continuous subarrays whose sum equals to k. I found the following interesting code snippet on LeetCode:

public class Solution {
    public int subarraySum(int[] nums, int k) {
        int count = 0, sum = 0;
        HashMap < Integer, Integer > map = new HashMap < > ();
        map.put(0, 1);
        for (int i = 0; i < nums.length; i++) {
            sum += nums[i];
            if (map.containsKey(sum - k))
                count += map.get(sum - k);
            map.put(sum, map.getOrDefault(sum, 0) + 1);
        }
        return count;
    }
}

I liked the efficient solution and so I am trying to understand it; however I have two questions:

  1. What is the intuition behind storing the current sum and its frequency in the HashMap?
  2. What is the guarantee that the subarray that we detect is continuous?

Sample input: [1,1,1] and k=2;
Output: 2

3 Answers
Related